=== src/LMbench/scripts/Makefile ===
# Makefile for lmbench scripts subdir.
#$Id: Makefile,v 1.1 2002/12/09 19:46:34 deadline Exp $

get:
	get -s 

clean:
	-bk clean
